﻿; Declaration File for IncludeOnDemand()


; RESTRICTION: Because of the generated multiline Code, you cannot use this for way of OnDemand-Include
;              for Functions which will be used WITHIN expressions.
;					But there should be no Problem if you use them at the END of an expression.



; ---- Example 1 - small local Routine		-	just a small simple Routine, which is directly includet in the IncludeOnDemand.pbi Mainfile

Declare Min(Val1, Val2)							; Declaration should be the same as in the Procedure

Macro	Min(Val1, Val2)
	Call2ParamFunction(Val1, Val2, Min)		; <= use a Dummy-Macro to call a Funktion with the same Name as the Macro
	#IncludeUsed_Min = #True					; <= #IncludeUsed_Min is a Flag-Constant, to mark that the Function has been used
EndMacro




; ---- Example 2 - external Routine			-  a little more complex Function, located in a separate Include-File

Declare.s T2H(Text$)								; Declaration should be the same as in the Procedure

Macro	Text2HTML(Text)
	T2H(Text)										; <= no need to use a Dummy-Macro this time, because Macro-Name is different from Function-Name
	#IncludeUsed_Text2HTML = #True			; <= #IncludeUsed_Text2HTML is a Flag-Constant, to mark that the Function has been used
EndMacro




; ---- Example 3 -  Modules (easy way)		-	Modules are a bit more complex than 'usual' Procedures.
;															Because you need to Declare the Module before you can use the Functions of the Module
;															by using 'Module::Function()' Or 'UseModule XYZ', you need to include or 'initialize'
;															it first, otherwise you will end up with an 'XYZ() is not a Procedure, Array, ...' Error.
;															To 'initialize' it, you have to call the following Macro 'UseInclude_...' first
;															(like the usual PB-Init Commands:  InitSprite(), UsePNGImageDecoder(), etc.)

Macro	UseInclude_AboutBox														; Call 'UseInclude_..." once
	CompilerIf Not Defined(IncludeUsed_AboutBox, #PB_Constant)		; to 'initialise' the Includet Module (load Declaration and declare the Flag)
		XIncludeFile "Includes\Module_AboutBox_Declarations.pbi"		; <= File with the Declaration-Part of the Module
		#IncludeUsed_AboutBox = #True											; <= Flag-Constant to mark that the File has been includet
	CompilerEndIf
EndMacro




; ---- Example 4 - Modules (bullet proof)	-	In the 'bullet proof' version, you will get a Compiler-Error,
;															if you try to called a Function from a Modul which is Not available.
;															The reason for this could either be, that you have forgotten to 'initialize' the required
;															Modul by calling 'UseInclude_..." first, or that you try to call the Function
;															in the wrong NameSpace.
;															For either both Mistakes, the 'Bullet proof'-Version will give you a detailed CompilerError.

Macro	UseInclude_AboutBox_2													; Call 'UseInclude_..." once
	CompilerIf Not Defined(IncludeUsed_AboutBox_2, #PB_Constant)	; to 'initialise' the Includet Module (load Declaration and declare the Flag)
		XIncludeFile "Includes\Module_AboutBox_Declarations.pbi"		; <= File with the Declaration-Part of the Module
		#IncludeUsed_AboutBox_2 = #True										; <= Flag-Constant to mark that the File has been includet
	CompilerEndIf
EndMacro

; For earch public Function of the Module you want to make 'bullet proof', you need to generate a Macro like the following one.
; The Macro should be declared the same way as the original Function of the Modul is.
; e.g.: This Modul includes a public Funktion: 'Set(what, text, image = 0)'

; RESTRICTION: Because of the generated, multi-lined Code, you cannot use this, to bullet-proof Functions
;              which will be used within an argument or which give back a needed Return-Value.

Macro Set(what, text, image = 0)	
	
	CompilerIf Not Defined(IncludeUsed_AboutBox_2, #PB_Constant)		; Check if Modul already included
		IncludeOnDemandError_UseInclude("AboutBox_2", "About::Module")
	CompilerElse
		CompilerIf Not Defined(Set, #PB_Procedure)							; Check if Modul-Function is available in the actual NameSpace
			IncludeOnDemandError_FunktionNotAvailable("Set", "About")
		CompilerElse
			Call3ParamFunction(what, text, image, Set)						; use Dummy-Macro to call Funktion with same Name as the Macro
		CompilerEndIf
	CompilerEndIf
	
EndMacro

; --- the following Macros are for multiple usage from all OnDemand-includet Funktions:

Macro	Call0ParamFunction(FunctionName)	: FunctionName() : EndMacro
Macro	Call1ParamFunction(p1,FunctionName)	: FunctionName(p1) : EndMacro
Macro	Call2ParamFunction(p1,p2,FunctionName)	: FunctionName(p1,p2) : EndMacro
Macro	Call3ParamFunction(p1,p2,p3,FunctionName)	: FunctionName(p1,p2,p3) : EndMacro
Macro	Call4ParamFunction(p1,p2,p3,p4,FunctionName)	: FunctionName(p1,p2,p3,p4) : EndMacro
Macro	Call5ParamFunction(p1,p2,p3,p4,p5,FunctionName)	: FunctionName(p1,p2,p3,p4,p5) : EndMacro
Macro	Call6ParamFunction(p1,p2,p3,p4,p5,p6,FunctionName)	: FunctionName(p1,p2,p3,p4,p5,p6) : EndMacro
Macro	Call7ParamFunction(p1,p2,p3,p4,p5,p6,p7,FunctionName)	: FunctionName(p1,p2,p3,p4,p5,p6,p7) : EndMacro
Macro	Call8ParamFunction(p1,p2,p3,p4,p5,p6,p7,p8,FunctionName)	: FunctionName(p1,p2,p3,p4,p5,p6,p7,p8) : EndMacro
Macro	Call9ParamFunction(p1,p2,p3,p4,p5,p6,p7,p8,p9,FunctionName)	: FunctionName(p1,p2,p3,p4,p5,p6,p7,p8,p9) : EndMacro

Macro IncludeOnDemandError_UseInclude(InitCall, Func)
	CompilerError "> UseInclude_"+InitCall+" < must be called, before you can use any of the "+Func+"-Functions"
EndMacro

Macro IncludeOnDemandError_FunktionNotAvailable(Function, Mod)
	CompilerError Function+"() is not a defined Function, Array or LinkedList in the actual NameSpace. If you have tried to call a Function from the Module '"+Mod+"', you should use '"+Mod+"::"+Function+"()' Or call 'UseModule "+Mod+"' first."
EndMacro

; IDE Options = PureBasic 5.42 Beta 3 LTS (Windows - x86)
; CursorPosition = 42
; FirstLine = 35
; Folding = ---
; EnableUnicode
; EnableXP
; EnableCompileCount = 4
; EnableBuildCount = 0
; EnableExeConstant